module Renderer where

import SDL (($=))

import qualified Graphics.Rendering.OpenGL as GL

import Foreign

initSpriteRenderData = do
  quadVAO <- GL.genObjectName
  quadVBO <- GL.genObjectName

  GL.bindBuffer GL.ArrayBuffer $= Just quadVBO
  withArray rawVertices $ \ptr ->
    GL.bufferData GL.ArrayBuffer $=
      ( fromIntegral $ length rawVertices * sizeOf (0 :: Float)
      , ptr
      , GL.StaticDraw
      )

  GL.bindVertexArrayObject $= Just quadVAO

  GL.vertexAttribArray (GL.AttribLocation 0) $= GL.Enabled

  GL.vertexAttribPointer (GL.AttribLocation 0) $=
    ( GL.ToFloat
    , GL.VertexArrayDescriptor 4 GL.Float 0 (plusPtr nullPtr 0)
    )

  GL.bindBuffer GL.ArrayBuffer $= Nothing
  GL.bindVertexArrayObject $= Nothing
  where
    rawVertices :: [Float]
    rawVertices =
      [ 0, 1, 0, 0
      , 1, 0, 1, 0
      , 0, 0, 0, 0
    
      , 0, 1, 0, 1
      , 1, 1, 1, 1
      , 1, 0, 1, 0
      ]
